#!/usr/bin/env bash

function miner_ver() {
  local MINER_VER=$SRBMINER_VER
  [[ -z $MINER_VER ]] && MINER_VER=$MINER_LATEST_VER
  echo $MINER_VER
}


function miner_config_echo() {
  local MINER_VER=`miner_ver`
  miner_echo_config_file "/hive/miners/$MINER_NAME/$MINER_VER/$MINER_NAME.conf"
}

function miner_config_gen() {
  local MINER_CONFIG="$MINER_DIR/$MINER_VER/$MINER_NAME.conf"
  mkfile_from_symlink $MINER_CONFIG

  local algo=$SRBMINER_ALGO

  local pool=
  while read -r line; do
    [[ ! -z $pool ]] && pool+='!'
    [[ $SRBMINER_TLS -eq 1 ]] && local pool+='stratum+ssl://'
    pool+=$line
  done <<< "$SRBMINER_URL"

  local worker=
  [[ -n $SRBMINER_WORKER ]] && worker=".$SRBMINER_WORKER"
  local wallet=${SRBMINER_TEMPLATE}${worker}


  local pass=
  [[ -n $SRBMINER_PASS ]] && pass=" --password $SRBMINER_PASS"

  if [[ ! -z $SRBMINER_ALGO2 ]]; then
    algo+=';'$SRBMINER_ALGO2

    local pool2=
    while read -r line; do
      [[ ! -z $pool2 ]] && pool2+='!'
      [[ $SRBMINER_TLS2 -eq 1 ]] && local pool2+='stratum+ssl://'
      pool2+=$line
    done <<< "$SRBMINER_URL2"
    pool+=';'$pool2

    worker=
    [[ -n $SRBMINER_WORKER2 ]] && worker+=".$SRBMINER_WORKER2"
    wallet+=';'${SRBMINER_TEMPLATE2}${worker}

    if [[ -n $SRBMINER_PASS2 ]]; then
      [[ -z $pass ]] && pass=" --password "
      pass+=';'$SRBMINER_PASS2
    fi
  fi

  local user_config=`echo $SRBMINER_USER_CONFIG`
  [[ -n $SRBMINER_USER_CONFIG2 ]] && user_config+=" "`echo $SRBMINER_USER_CONFIG2`

  #generating config
  echo "--algorithm $algo --pool $pool --wallet ${wallet}${pass} $user_config" > $MINER_CONFIG
}
